package org.gcube.gcat.moderation;

import org.gcube.com.fasterxml.jackson.annotation.JsonIgnore;
import org.gcube.gcat.ContextTest;
import org.gcube.gcat.api.moderation.CMItemStatus;
import org.gcube.gcat.moderation.thread.ModerationThread;
import org.gcube.gcat.persistence.ckan.CKANUser;
import org.junit.Test;

/**
 * @author Luca Frosini (ISTI - CNR)
 */
public class ModerationThreadTest extends ContextTest {

	@Test
	@JsonIgnore
	public void test() throws Exception {
		ModerationThread moderationThread = ModerationThread.getDefaultInstance();
		moderationThread.setItemCoordinates("my_first_restful_transaction_model", "RESTful Transaction Model", "https://data.dev.d4science.org/ctlg/devVRE/my_first_restful_transaction_model");
		CKANUser ckanUser = new CKANUser();
		ckanUser.setName(CKANUser.getCKANUsername());
		ckanUser.read();
		moderationThread.setCKANUser(ckanUser);
		moderationThread.postItemCreated();
		moderationThread.postItemUpdated();
		moderationThread.postItemRejected("Non mi garba");
		moderationThread.postItemApproved("Ora mi garba");
		moderationThread.postUserMessage(CMItemStatus.APPROVED, "Well Done");
		Thread.sleep(1000);
	}
	
}
